package micopy.com.daniminguet.es;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Scanner;

public class MiCopy {
	public static void main(String[] args) {
		Scanner lector = new Scanner(System.in);
		
		//Se pide el archivo de origen
		System.out.println("Introduce la ruta del archivo de origen:");
		String archivoOrigenString = lector.nextLine();
		
		File archivoOrigen = new File(archivoOrigenString);
		
		try {
			//Si el archivo de origen existe, se pedirá el archivo de destino
			if(archivoOrigen.exists()) {
				System.out.println("Introduce la ruta del archivo de destino:");
				String archivoDestinoString = lector.nextLine();
				
				File archivoDestino = new File(archivoDestinoString);
				
				//Si el archivo de destino existe y tiene permisos para escribir, sobreescribirá los datos
				if(archivoDestino.exists()) {
					if(archivoDestino.canWrite()) {
						InputStream isCopiar = new FileInputStream(archivoOrigen);
						OutputStream osPegar = new FileOutputStream(archivoDestino);
						copiar(isCopiar, osPegar);
						isCopiar.close();
						osPegar.close();
					} else {
						System.out.println("No tienes permisos para modificar el archivo de destino");
					}
				//Si el archivo de destino no existe, lo crea y escribe los datos
				} else {
					System.out.println("Nuevo archivo creado");
					archivoDestino.createNewFile();
					InputStream isCopiar = new FileInputStream(archivoOrigen);
					OutputStream osPegar = new FileOutputStream(archivoDestino);
					copiar(isCopiar, osPegar);
					isCopiar.close();
					osPegar.close();
				}
				System.out.println();
				try {
					Thread.sleep(1000);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
				
				String linea;
				
				//Mostrará el contenido de los dos archivos para verificar que funciona correctamente
				FileReader frOrigen = new FileReader(archivoOrigen);
				BufferedReader brOrigen = new BufferedReader(frOrigen);
				System.out.println("Contenido del archivo de origen:");
				System.out.println();
				while((linea = brOrigen.readLine()) != null) {
					System.out.println(linea);
				}
				System.out.println();
				frOrigen.close();
				brOrigen.close();
				
				linea = null;
				try {
					Thread.sleep(1000);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
				
				FileReader frDestino = new FileReader(archivoDestino);
				BufferedReader brDestino = new BufferedReader(frDestino);
				System.out.println("Contenido del archivo de destino:");
				System.out.println();
				while((linea = brDestino.readLine()) != null) {
					System.out.println(linea);
				}
				frDestino.close();
				brDestino.close();
			//Si el archivo no existe, el programa finalizará
			} else {
				System.out.println("El archivo de origen no existe o no se encuentra la ruta correcta");
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public static void copiar(InputStream isCopiar, OutputStream osPegar) throws IOException {
		int c;
		
		//Proceso de copia
		System.out.println("Copiando archivo...");
		System.out.print("(");
		try {
			while((c = isCopiar.read()) != -1) {
				osPegar.write(c);
				System.out.print("|");
				Thread.sleep(40);
			}
		} catch (InterruptedException ie) {
			
		}
		System.out.println(")");
		System.out.println("Archivo copiado con éxito!!");
	}
}